 #define DD_BASE 0x40000800
 #define FUNC          QUEUE[ 0 ]
 #define SWCHA         QUEUE[ 1 ]
 #define SWCHB         QUEUE[ 2 ]
 #define INPT4         QUEUE[ 3 ]
 #define VB_TIME       QUEUE[ 4 ]
 #define OS_TIME       QUEUE[ 5 ]
 #define MODE          QUEUE[ 6 ]
 #define FRAME         QUEUE[ 7 ]
 #define AUDV          ((unsigned char *)( DD_BASE + 12 ))
 #define AUDF          ((unsigned char *)( DD_BASE + 10 ))
 #define AUDC          ((unsigned char *)( DD_BASE + 8 ))
 #define AUDV0         QUEUE[ 12 ]
 #define AUDF0         QUEUE[ 10 ]
 #define AUDC0         QUEUE[ 8 ]
 #define AUDV1         QUEUE[ 13 ]
 #define AUDF1         QUEUE[ 11 ]
 #define AUDC1         QUEUE[ 9 ]
 #define AUDIO_QUIET    8
 #define RUN_INIT        0
 #define RUN_MENU_VB     1
 #define RUN_MENU_OS     2
 #define RUN_GAME_VB     3
 #define RUN_GAME_OS     4
 #define RUN_SPLASH_VB   5
 #define RUN_SPLASH_OS   6
 #define RUN_INIT_LEVEL  7
 #define DS_MENU_CONTROL    14
 #define DS_MENU_A          15
 #define DS_MENU_COLOR      16
 #define DS_GRP0            0
 #define DS_GRP1            1
 #define DS_HMP0            2
 #define DS_HMP1            3
 #define DS_MISSILE0        4
 #define DS_MISSILE1        5
 #define DS_BALL            6
 #define DS_COLOR           7
 #define DS_SIZE            8
 #define DS_RADAR_CONTROL   9
 #define DS_RADAR_GRP0      10
 #define DS_RADAR_GRP1      11
 #define DS_FORMATION_GRP0  12
 #define DS_FORMATION_GRP1  13
 #define DS_PF0L            14
 #define DS_PF1L            15
 #define DS_PF2L            16
 #define DS_PF0R            17
 #define DS_PF1R            18
 #define DS_PF2R            19
 #define DS_STATION_COLOR   20
 #define SCORE_COLOR        10
 #define SPLASH_SCREEN_GRAPHICS_ROM  27470
 #define SPLASH_SCREEN_GFX_SIZE      150
 #define MAIN_MENU_GRAPHICS_ROM      27620
 #define MAIN_MENU_GFX_SIZE          878
 #define MAIN_MENU_GRAPHICS_RAM      21
 #define LOGO_HEIGHT                 90
 #define MAIN_MENU_COLORS_OFFSET     720
 #define MAIN_MENU_OPTIONS_OFFSET    0
 #define MAIN_MENU_CONTROL_OFFSET    672
 #define MENU_DIGITS                 31672
 #define TITLE_SCREEN_COLOR_OFFSET   720
 #define TITLE_SCREEN_COLOR_SIZE     158
 #define START_COLOR_OFFSET          878
 #define MENU_GRAPHICS_OFFSET       ((unsigned short int *)( 26982 ))
 #define MENU_FIRST_OPTION_ID        1
 #define MENU_QUADRANT_ID            1
 #define MENU_SECTOR_ID              2
 #define MENU_LEVEL_ID               3
 #define MENU_TV_TYPE_ID             4
 #define MENU_START_ID               5
 #define MENU_LAST_ID                6
 #define MENU_HIGH_ID                7
 #define MM_JOYSTICK_TIMER          QUEUE[ 14 ]
 #define MM_FIRE_DOWN               QUEUE[ 15 ]
 #define MM_SELECTED_OPTION         QUEUE[ 16 ]
 #define MM_QUADRANT                QUEUE[ 17 ]
 #define MM_INITIAL_SECTOR          QUEUE[ 18 ]
 #define MM_LEVEL                   QUEUE[ 19 ]
 #define MM_TV_TYPE                 QUEUE[ 20 ]
 #define OPTION_BETA                 28498
 #define OPTION_GAMMA                28513
 #define OPTION_DELTA                28506
 #define OPTION_NORMAL               28537
 #define OPTION_EASY                 28521
 #define OPTION_HARD                 28561
 #define OPTION_PAL                  28577
 #define OPTION_SECAM                28593
 #define SOUND_FREQ                 ((unsigned char *)( 31965 ))
 #define SOUND_VOL                  ((unsigned char *)( 32277 ))
 #define SOUND_PLAYER_SHOOTS_ID      17
 #define SOUND_CANNON_HIT_ID         191
 #define SOUND_ITYPE_SPY_HIT_ID      244
 #define TUNE_ROUND_CLEAR_A          139
 #define TUNE_ROUND_CLEAR_B          157
 #define SOUND_ETYPE_HIT_ID          260
 #define SOUND_PTYPE_HIT_ID          203
 #define SOUND_ASTEROID_ID           284
 #define SOUND_FORMATION_ID          219
 #define SOUND_CONDITION_RED_ID      265
 #define SOUND_CONDITION_RED_LOOP    261
 #define SOUND_MENU_BLIP_ID          1
 #define SOUND_MINE_ID               297
 #define SOUND_PLAYER_HIT_ID         311
 #define TUNE_NEW_GAME_A             69
 #define TUNE_NEW_GAME_B             121
 #define TUNE_HIGH_SCORE_A           69
 #define TUNE_HIGH_SCORE_B           121
 #define SAMPLES                    ((unsigned short int *)( 31642 ))
 #define SAMPLE_SIZES               ((unsigned short int *)( 31652 ))
 #define SAMPLE_RATES               ((unsigned short int *)( 31662 ))
 #define SAMPLE_BLAST_OFF           1
 #define SAMPLE_ALERT_ALERT         2
 #define SAMPLE_BATTLESTATIONS      3
 #define SAMPLE_SPY_SHIP_SIGHTED    4
 #define SAMPLE_CONDITION_RED       5
 #define DATASTREAM_SIZE             160
 #define REPOSITION_SIZE             5
 #define CLEAR_DS_INT                24
 #define CLEAR_DS_INT_SIZE           513
 #define P0_DATASTREAM               391
 #define P1_DATASTREAM               556
 #define HMP0_DATASTREAM             721
 #define HMP1_DATASTREAM             887
 #define MISSILE0_DATASTREAM         1053
 #define MISSILE1_DATASTREAM         1219
 #define BALL_DATASTREAM             1385
 #define COLOR_DATASTREAM            1551
 #define SIZE_DATASTREAM             1716
 #define JUMP_DATASTREAM             34
 #define SCORE_DATASTREAM            356
 #define EXIT_JUMP_DS               (*(unsigned short int *)(DD_BASE + 354 ))
 #define EXIT_SCORE_DS              (*(unsigned short int *)(DD_BASE + 384 ))
 #define RADAR_HEIGHT                20
 #define RADAR_P0                    1876
 #define RADAR_P1                    1896
 #define FORMATION_P0                1916
 #define FORMATION_P1                1936
 #define PLAYFIELD_DATA              1956
 #define PF0L                        0
 #define PF1L                        20
 #define PF2L                        40
 #define PF0R                        60
 #define PF1R                        80
 #define PF2R                        100
 #define PF_FONT                    ((unsigned char *)( 31800 ))
 #define PF_FONT_HEIGHT              15
 #define RADAR_CONTROL               2076
 #define NORMAL_KERNEL               61834
 #define EXIT_KERNEL                 61906
 #define INIT_LEVEL_KERNEL           61885
 #define FIRST_RESP0                 62787
 #define FIRST_RESP1                 63110
 #define FIRST_RESM0                 63430
 #define FIRST_RESM1                 63715
 #define FIRST_RESBL                 62464
 #define RESP0STROBE23               62787
 #define RESP0STROBE28               62844
 #define RESP0STROBE33               62852
 #define RESP0STROBE38               62864
 #define RESP0STROBE43               62880
 #define RESP0STROBE48               62900
 #define RESP0STROBE53               62924
 #define RESP0STROBE58               62953
 #define RESP0STROBE63               62986
 #define RESP0STROBE68               63022
 #define RESP0STROBE73               63066
 #define RESP1STROBE23               63293
 #define RESP1STROBE28               63350
 #define RESP1STROBE33               63358
 #define RESP1STROBE38               63370
 #define RESP1STROBE43               63386
 #define RESP1STROBE48               63406
 #define RESP1STROBE53               63233
 #define RESP1STROBE58               63261
 #define RESP1STROBE63               63110
 #define RESP1STROBE68               63146
 #define RESP1STROBE73               63190
 #define RESM0STROBE23               63430
 #define RESM0STROBE28               63439
 #define RESM0STROBE33               63448
 #define RESM0STROBE38               63462
 #define RESM0STROBE43               63480
 #define RESM0STROBE48               63502
 #define RESM0STROBE53               63527
 #define RESM0STROBE58               63558
 #define RESM0STROBE63               63596
 #define RESM0STROBE68               63632
 #define RESM0STROBE73               63672
 #define RESM1STROBE23               63715
 #define RESM1STROBE28               63724
 #define RESM1STROBE33               63733
 #define RESM1STROBE38               63747
 #define RESM1STROBE43               63765
 #define RESM1STROBE48               63787
 #define RESM1STROBE53               63812
 #define RESM1STROBE58               63843
 #define RESM1STROBE63               63881
 #define RESM1STROBE68               63917
 #define RESM1STROBE73               63957
 #define RESBLSTROBE23               62464
 #define RESBLSTROBE28               62521
 #define RESBLSTROBE33               62529
 #define RESBLSTROBE38               62541
 #define RESBLSTROBE43               62557
 #define RESBLSTROBE48               62577
 #define RESBLSTROBE53               62601
 #define RESBLSTROBE58               62630
 #define RESBLSTROBE63               62663
 #define RESBLSTROBE68               62699
 #define RESBLSTROBE73               62743
 #define SCORE_KERNEL                62102
 #define EXIT_SCORE_KERNEL           62161
 #define IMAGE_HEIGHTS               27334
 #define IMAGE_SHIFT                 27270
 #define IMAGE_GRAPHICS              26998
 #define MISSILE_GRAPHICS            27302
 #define STATION_IMAGES              2132
 #define STATION_HEIGHT              66
 #define OBJECT_COLORS_NTSC          28621
 #define OBJECT_COLORS_SIZE          50
 #define OBJECT_COLORS_RAM           2082
 #define SHIFTING_SPRITES            15
 #define STATION_HORIZONTAL_ID       0
 #define STATION_VERTICAL_ID         1
 #define ASTEROID_ID                 25
 #define MINE_ID                     28
 #define SHIP_ID                     29
 #define SHIP_HEIGHT                 16
 #define ETYPE_ID                    37
 #define ITYPE_ID                    53
 #define PTYPE_ID                    69
 #define SPY_ID                      85
 #define POD_ID                      101
 #define CORE_HORIZONTAL_ID          122
 #define CORE_VERTICAL_ID            123
 #define FORMATION_ID                102
 #define FIRST_MISSILE_GRAPHIC_ID    106
 #define SHOT_HORIZONTAL_ID          0
 #define SHOT_DIAGONAL_TLBR_ID       1
 #define SHOT_DIAGONAL_TRBL_ID       2
 #define SHOT_VERTICAL_ID            3
 #define SHOT_STATION_ID             4
 #define ENERGY_POD_HORIZONTAL_ID    8
 #define ENERGY_POD_VERTICAL_ID      12
 #define HORIZONTAL_POD_DIFF_ID      124
 #define VERTICAL_POD_DIFF_ID        130
 #define EXPLOSION_PLAYER_ID         9
 #define EXPLOSION_MINE_ID           13
 #define EXPLOSION_STATION_ID        16
 #define EXPLOSION_ENEMYSHIP_ID      19
 #define EXPLOSION_ASTEROIDPOD_ID    22
 #define POINTS_200_ID               2 // spyship bonuses
 #define POINTS_400_ID               3
 #define POINTS_800_ID               4
 #define POINTS_500_ID               6 // formation bonuses
 #define POINTS_1000_ID              7
 #define POINTS_1500_ID              5
 #define GAMEOVER_ID                 8
