// Midway levels

const unsigned char alpha_1[] =
{
  253/2, 504/4, // ship starting X, Y location
  3,            // station count
  0x07,         // VS VS VS
  320/2, 255/4, // station 1 X, Y location
  224/2, 320/4, // station 2 X, Y location
   96/2, 576/4  // station 3 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    3,          // station count
//    VS + 320, 255,    // station 1 X, Y location
//    VS + 224, 320,   // station 2 X, Y location
//    VS + 96, 576   // station 3 X, Y location
};

const unsigned char alpha_2[] =
{
  253/2, 934/4, // ship starting X, Y location
  4,            // station count
  0x0f,         // VS VS VS VS
  192/2, 420/4, // station 1 X, Y location
  320/2, 575/4, // station 2 X, Y location
  128/2, 610/4, // station 3 X, Y location
  256/2, 710/4  // station 4 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    4,          // station count
//    VS + 192,  420,   // station 1 X, Y location
//    VS + 320, 575,   // station 2 X, Y location
//    VS + 128, 610,   // station 3 X, Y location
//    VS + 256, 710   // station 4 X, Y location
};

const unsigned char alpha_3[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0xff,         // all VS
  160/2, 334/4, // station 1 X, Y location
  160/2, 438/4, // station 2 X, Y location
  160/2, 542/4, // station 3 X, Y location
  160/2, 646/4, // station 4 X, Y location
  288/2, 384/4, // station 5 X, Y location
  288/2, 488/4, // station 6 X, Y location
  288/2, 592/4, // station 7 X, Y location
  288/2, 696/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    VS + 160, 334,   // station 1 X, Y location
//    VS + 160,  438,   // station 2 X, Y location
//    VS + 160, 542,   // station 3 X, Y location
//    VS + 160,  646,   // station 4 X, Y location
//    VS + 288, 384,   // station 5 X, Y location
//    VS + 288, 488,   // station 6 X, Y location
//    VS + 288, 592,   // station 7 X, Y location
//    VS + 288, 696    // station 8 X, Y location
};

const unsigned char alpha_4[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0xb2,         // VS HS VS VS   HS HS VS HS
    0/2,  18/4, // station 1 X, Y location
  288/2,  99/4, // station 2 X, Y location
  412/2, 139/4, // station 3 X, Y location
  412/2, 308/4, // station 4 X, Y location
  320/2, 399/4, // station 5 X, Y location
  256/2, 570/4, // station 6 X, Y location
  192/2, 703/4, // station 7 X, Y location
  256/2, 896/4  // station 8 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    8,          // station count
//    HS + 0, 18,   // station 1 X, Y location
//    VS + 288, 99,   // station 2 X, Y location
//    HS + 412, 139,   // station 3 X, Y location
//    HS + 412, 308,   // station 4 X, Y location
//    VS + 320, 399,   // station 5 X, Y location
//    VS + 256, 570,   // station 6 X, Y location
//    HS + 192, 703,   // station 7 X, Y location
//    VS + 256, 896    // station 8 X, Y location
};

const unsigned char alpha_5[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0x96,         // VS HS HS VS   HS VS VS HS
  256/2, 299/4, // station 1 X, Y location
  416/2, 412/4, // station 2 X, Y location
   26/2, 512/4, // station 3 X, Y location
  164/2, 508/4, // station 4 X, Y location
  225/2, 457/4, // station 5 X, Y location
  227/2, 565/4, // station 6 X, Y location
  292/2, 508/4, // station 7 X, Y location
  352/2, 512/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    HS + 256, 299,   // station 1 X, Y location
//    VS + 416, 412,   // station 2 X, Y location
//    VS + 26, 512,   // station 3 X, Y location
//    HS + 164, 508,   // station 4 X, Y location
//    VS + 225, 457,   // station 5 X, Y location
//    HS + 227, 565,   // station 6 X, Y location
//    HS + 292, 508,   // station 7 X, Y location
//    VS + 352, 512    // station 8 X, Y location
};

const unsigned char alpha_6[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0x4e,         // HS VS HS HS   VS VS VS HS
  356/2, 125/4, // station 1 X, Y location
  384/2, 128/4, // station 2 X, Y location
  384/2, 186/4, // station 3 X, Y location
  224/2, 286/4, // station 4 X, Y location
  226/2, 344/4, // station 5 X, Y location
  292/2, 527/4, // station 6 X, Y location
  320/2, 530/4, // station 7 X, Y location
   91/2, 757/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    HS + 356, 125,   // station 1 X, Y location
//    VS + 384, 128,   // station 2 X, Y location
//    VS + 384, 186,   // station 3 X, Y location
//    VS + 224, 286,   // station 4 X, Y location
//    HS + 226, 344,   // station 5 X, Y location
//    HS + 292, 527,   // station 6 X, Y location
//    VS + 320, 530,   // station 7 X, Y location
//    HS + 91, 757    // station 8 X, Y location
};

const unsigned char alpha_7[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count,
  0x00,         // all HS
    0/2, 533/4, // station 1 X, Y location
   64/2, 533/4, // station 2 X, Y location
  128/2, 533/4, // station 3 X, Y location
  192/2, 533/4, // station 4 X, Y location
  256/2, 533/4, // station 5 X, Y location
  320/2, 533/4, // station 6 X, Y location
  384/2, 533/4, // station 7 X, Y location
  448/2, 533/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    HS + 0, 533,   // station 1 X, Y location
//    HS + 64, 533,   // station 2 X, Y location
//    HS + 128, 533,   // station 3 X, Y location
//    HS + 192, 533,   // station 4 X, Y location
//    HS + 256, 533,   // station 5 X, Y location
//    HS + 320, 533,   // station 6 X, Y location
//    HS + 384, 533,   // station 7 X, Y location
//    HS + 448, 533    // station 8 X, Y location
};

const unsigned char alpha_8[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0xee,         // VS VS VS HS   VS VS VS HS
  128/2, 507/4, // station 1 X, Y location
  160/2, 450/4, // station 2 X, Y location
  224/2, 413/4, // station 3 X, Y location
  288/2, 450/4, // station 4 X, Y location
  320/2, 507/4, // station 5 X, Y location
  160/2, 598/4, // station 6 X, Y location
  224/2, 598/4, // station 7 X, Y location
  288/2, 598/4  // station 8 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    8,          // station count
//    HS + 128, 507,   // station 1 X, Y location
//    VS + 160, 450,   // station 2 X, Y location
//    VS + 224, 413,   // station 3 X, Y location
//    VS + 288, 450,   // station 4 X, Y location
//    HS + 320, 507,   // station 5 X, Y location
//    VS + 160, 598,   // station 6 X, Y location
//    VS + 224, 598,   // station 7 X, Y location
//    VS + 288, 598    // station 8 X, Y location
};

const unsigned char alpha_9[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0xe3,         // VS VS VS HS   HS HS VS VS
   64/2, 146/4, // station 1 X, Y location
  352/2, 256/4, // station 2 X, Y location
  292/2, 512/4, // station 3 X, Y location
  226/2, 562/4, // station 4 X, Y location
  164/2, 608/4, // station 5 X, Y location
  224/2, 768/4, // station 6 X, Y location
  416/2, 819/4, // station 7 X, Y location
   96/2, 920/4  // station 8 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    8,          // station count
//    VS + 64, 146,   // station 1 X, Y location
//    VS + 352, 256,   // station 2 X, Y location
//    HS + 292, 512,   // station 3 X, Y location
//    HS + 226, 562,   // station 4 X, Y location
//    HS + 164, 608,   // station 5 X, Y location
//    VS + 224, 768,   // station 6 X, Y location
//    VS + 416, 819,   // station 7 X, Y location
//    VS + 96, 920    // station 8 X, Y location
};

const unsigned char alpha_10[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0x4b,         // HS VS HS HS  VS HS VS VS
  416/2,  18/4, // station 1 X, Y location
   32/2, 164/4, // station 2 X, Y location
  228/2, 158/4, // station 3 X, Y location
  352/2, 199/4, // station 4 X, Y location
  164/2, 256/4, // station 5 X, Y location
  192/2, 560/4, // station 6 X, Y location
   96/2, 796/4, // station 7 X, Y location
  484/2, 813/4  // station 8 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    8,          // station count
//    VS + 416, 18,   // station 1 X, Y location
//    VS + 32, 164,   // station 2 X, Y location
//    HS + 228, 158,   // station 3 X, Y location
//    VS + 352, 199,   // station 4 X, Y location
//    HS + 164, 256,   // station 5 X, Y location
//    HS + 192, 560,   // station 6 X, Y location
//    VS + 96, 796,   // station 7 X, Y location
//    HS + 484, 813    // station 8 X, Y location
};

const unsigned char alpha_11[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0x77,         // HS VS VS VS   HS VS VS VS
  165/2, 397/4, // station 1 X, Y location
  225/2, 397/4, // station 2 X, Y location
  290/2, 397/4, // station 3 X, Y location
  195/2, 447/4, // station 4 X, Y location
  273/2, 455/4, // station 5 X, Y location
  165/2, 560/4, // station 6 X, Y location
  225/2, 560/4, // station 7 X, Y location
  288/2, 557/4  // station 8 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    8,          // station count
//    VS + 165, 397,   // station 1 X, Y location
//    VS + 225, 397,   // station 2 X, Y location
//    VS + 290, 397,   // station 3 X, Y location
//    HS + 195, 447,   // station 4 X, Y location
//    VS + 273, 455,   // station 5 X, Y location
//    VS + 165, 560,   // station 6 X, Y location
//    VS + 225, 560,   // station 7 X, Y location
//    HS + 288, 557    // station 8 X, Y location
};

const unsigned char alpha_12[] =
// same as alpha_7 except for station 8
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0x80,         // VS HS HS HS  HS HS HS HS
    0/2, 533/4, // station 1 X, Y location
   64/2, 533/4, // station 2 X, Y location
  128/2, 533/4, // station 3 X, Y location
  192/2, 533/4, // station 4 X, Y location
  256/2, 533/4, // station 5 X, Y location
  320/2, 533/4, // station 6 X, Y location
  384/2, 533/4, // station 7 X, Y location
  448/2, 537/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    HS + 0, 533,   // station 1 X, Y location
//    HS + 64, 533,   // station 2 X, Y location
//    HS + 128, 533,   // station 3 X, Y location
//    HS + 192, 533,   // station 4 X, Y location
//    HS + 256, 533,   // station 5 X, Y location
//    HS + 320, 533,   // station 6 X, Y location
//    HS + 384, 533,   // station 7 X, Y location
//    VS + 448, 537    // station 8 X, Y location
};

// 13 same as 9
// 14 same as 5
// 15 same as 10

const unsigned char alpha_16[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0x6c,         // HS VS VS HS   VS VS HS HS
  228/2, 224/4, // station 1 X, Y location
  100/2, 292/4, // station 2 X, Y location
   32/2, 455/4, // station 3 X, Y location
   64/2, 642/4, // station 4 X, Y location
  228/2, 769/4, // station 5 X, Y location
  352/2, 698/4, // station 6 X, Y location
  416/2, 512/4, // station 7 X, Y location
  384/2, 351/4  // station 8 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    8,          // station count
//    HS + 228, 224,   // station 1 X, Y location
//    HS + 100, 292,   // station 2 X, Y location
//    VS + 32, 455,   // station 3 X, Y location
//    VS + 64, 642,   // station 4 X, Y location
//    HS + 228, 769,   // station 5 X, Y location
//    VS + 352, 698,   // station 6 X, Y location
//    VS + 416, 512,   // station 7 X, Y location
//    HS + 384, 351    // station 8 X, Y location
};

const unsigned char alpha_17[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0x40,         // HS VS HS HS   HS HS HS HS
  256/2,  55/4, // station 1 X, Y location
  192/2, 264/4, // station 2 X, Y location
  320/2, 352/4, // station 3 X, Y location
  228/2, 395/4, // station 4 X, Y location
  128/2, 447/4, // station 5 X, Y location
  292/2, 512/4, // station 6 X, Y location
    0/2, 679/4, // station 7 X, Y location
  384/2, 906/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    HS + 256, 55,   // station 1 X, Y location
//    HS + 192, 264,   // station 2 X, Y location
//    HS + 320, 352,   // station 3 X, Y location
//    HS + 228, 395,   // station 4 X, Y location
//    HS + 128, 447,   // station 5 X, Y location
//    HS + 292, 512,   // station 6 X, Y location
//    VS + 0, 679,   // station 7 X, Y location
//    HS + 384, 906    // station 8 X, Y location
};

// 18 same as 12.  Starting with 18 they repeat in this order:
// alpha_12,
// alpha_9,
// alpha_5,
// alpha_10,
// alpha_16,
// alpha_17,

#ifdef COMPACT_LEVELS
const unsigned short int alpha_levels[] =
{
  (unsigned short int) alpha_1,    // 1
  (unsigned short int) &alpha_2,    // 2
  (unsigned short int) alpha_3,    // 3
  (unsigned short int) alpha_4,    // 4
  (unsigned short int) alpha_5,    // 5
  (unsigned short int) alpha_6,    // 6
  (unsigned short int) alpha_7,    // 7
  (unsigned short int) alpha_8,    // 8
  (unsigned short int) alpha_9,    // 9
  (unsigned short int) alpha_10,   // 10
  (unsigned short int) alpha_11,   // 11
  (unsigned short int) alpha_12,   // 12 18 24
  (unsigned short int) alpha_9,    // 13 19 ...
  (unsigned short int) alpha_5,    // 14 20
  (unsigned short int) alpha_10,   // 15 21
  (unsigned short int) alpha_16,   // 16 22
  (unsigned short int) alpha_17    // 17 23
};

#else

const unsigned char * const alpha_levels[] =
{
    alpha_1,    // 1
    alpha_2,    // 2
    alpha_3,    // 3
    alpha_4,    // 4
    alpha_5,    // 5
    alpha_6,    // 6
    alpha_7,    // 7
    alpha_8,    // 8
    alpha_9,    // 9
    alpha_10,   // 10
    alpha_11,   // 11
    alpha_12,   // 12 18 24
    alpha_9,    // 13 19 ...
    alpha_5,    // 14 20
    alpha_10,   // 15 21
    alpha_16,   // 16 22
    alpha_17    // 17 23
};
#endif
