// Namco alternative levels

const unsigned char beta_1[] =
{
  253/2, 934/4, // ship starting X, Y location
  3,            // station count
  0x07,         // VS VS VS
  160/2, 583/4, // station 1 X, Y location
  224/2, 795/4, // station 2 X, Y location
  288/2, 741/4  // station 3 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    3,          // station count
//    VS + 160, 583,   // station 1 X, Y location
//    VS + 224, 795,   // station 2 X, Y location
//    VS + 288, 741,   // station 3 X, Y location
};

const unsigned char beta_2[] =
{
  253/2, 504/4, // ship starting X, Y location
  4,            // station count
  0x03,         // HS HS VS VS
   64/2, 327/4, // station 1 X, Y location
   64/2, 455/4, // station 2 X, Y location
  356/2, 418/4, // station 3 X, Y location
  448/2, 418/4  // station 4 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    4,          // station count
//    VS + 64, 327,   // station 1 X, Y location
//    VS + 64, 455,   // station 2 X, Y location
//    HS + 356, 418,   // station 3 X, Y location
//    HS + 448, 418,   // station 4 X, Y location
};

const unsigned char beta_9[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0x33,         // HS HS VS VS   HS HS VS VS
   64/2, 256/4, // station 1 X, Y location
  384/2, 256/4, // station 2 X, Y location
  164/2, 384/4, // station 3 X, Y location
  292/2, 384/4, // station 4 X, Y location
  163/2, 583/4, // station 5 X, Y location
  291/2, 583/4, // station 6 X, Y location
   67/2, 703/4, // station 7 X, Y location
  387/2, 703/4  // station 8 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    8,          // station count
//    VS + 64, 256,   // station 1 X, Y location
//    VS + 384, 256,   // station 2 X, Y location
//    HS + 164, 384,   // station 3 X, Y location
//    HS + 292, 384,   // station 4 X, Y location
//    VS + 163, 583,   // station 5 X, Y location
//    VS + 291, 583,   // station 6 X, Y location
//    HS + 67, 703,   // station 7 X, Y location
//    HS + 387, 703    // station 8 X, Y location
};

const unsigned char beta_10[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0x13,         // HS HS HS VS   HS HS VS VS
   96/2, 229/4, // station 1 X, Y location
  352/2, 229/4, // station 2 X, Y location
  164/2, 359/4, // station 3 X, Y location
  292/2, 359/4, // station 4 X, Y location
  226/2, 485/4, // station 5 X, Y location
  228/2, 595/4, // station 6 X, Y location
  228/2, 713/4, // station 7 X, Y location
  228/2, 831/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    VS + 96, 229,   // station 1 X, Y location
//    VS + 352, 229,   // station 2 X, Y location
//    HS + 164, 359,   // station 3 X, Y location
//    HS + 292, 359,   // station 4 X, Y location
//    VS + 226, 485,   // station 5 X, Y location
//    HS + 228, 595,   // station 6 X, Y location
//    HS + 228, 713,   // station 7 X, Y location
//    HS + 228, 831    // station 8 X, Y location
};

const unsigned char beta_11[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0x18,         // HS HS HS VS  VS HS HS HS
   64/2, 256/4, // station 1 X, Y location
  228/2, 256/4, // station 2 X, Y location
  384/2, 256/4, // station 3 X, Y location
  288/2, 384/4, // station 4 X, Y location
  160/2, 583/4, // station 5 X, Y location
   64/2, 703/4, // station 6 X, Y location
  228/2, 703/4, // station 7 X, Y location
  384/2, 703/4  // station 8 X, Y location
  
//    253, 504,   // ship starting X, Y location
//    8,          // station count
//    HS + 64, 256,   // station 1 X, Y location
//    HS + 228, 256,   // station 2 X, Y location
//    HS + 384, 256,   // station 3 X, Y location
//    VS + 288, 384,   // station 4 X, Y location
//    VS + 160, 583,   // station 5 X, Y location
//    HS + 64, 703,   // station 6 X, Y location
//    HS + 228, 703,   // station 7 X, Y location
//    HS + 384, 703    // station 8 X, Y location
};

const unsigned char beta_14[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0x9e,         // VS HS HS VS   VS VS VS HS
  356/2, 451/4, // station 1 X, Y location
  384/2, 454/4, // station 2 X, Y location
  384/2, 512/4, // station 3 X, Y location
  224/2, 582/4, // station 4 X, Y location
  224/2, 640/4, // station 5 X, Y location
  292/2, 768/4, // station 6 X, Y location
  321/2, 768/4, // station 7 X, Y location
   96/2, 829/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    HS + 356, 451,   // station 1 X, Y location
//    VS + 384, 454,   // station 2 X, Y location
//    VS + 384, 512,   // station 3 X, Y location
//    VS + 224, 582,   // station 4 X, Y location
//    VS + 224, 640,   // station 5 X, Y location
//    HS + 292, 768,   // station 6 X, Y location
//    HS + 321, 768,   // station 7 X, Y location
//    VS + 96, 829    // station 8 X, Y location
};

const unsigned char beta_17[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0xd9,         // VS VS HS VS   VS HS HS VS
   96/2, 199/4, // station 1 X, Y location
  164/2,  63/4, // station 2 X, Y location
  256/2,  63/4, // station 3 X, Y location
  352/2, 199/4, // station 4 X, Y location
  320/2, 355/4, // station 5 X, Y location
  256/2, 447/4, // station 6 X, Y location
  224/2, 568/4, // station 7 X, Y location
  224/2, 711/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    VS + 96, 199,   // station 1 X, Y location
//    HS + 164, 63,   // station 2 X, Y location
//    HS + 256, 63,   // station 3 X, Y location
//    VS + 352, 199,   // station 4 X, Y location
//    VS + 320, 355,   // station 5 X, Y location
//    HS + 256, 447,   // station 6 X, Y location
//    VS + 224, 568,   // station 7 X, Y location
//    VS + 224, 711    // station 8 X, Y location
};

// beta 18 is identical to alpha 8, except for ship starting position
const unsigned char beta_18[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0xee,         // VS VS VS HS  VS VS VS HS
  128/2, 507/4, // station 1 X, Y location
  160/2, 450/4, // station 2 X, Y location
  224/2, 413/4, // station 3 X, Y location
  288/2, 450/4, // station 4 X, Y location
  320/2, 507/4, // station 5 X, Y location
  160/2, 598/4, // station 6 X, Y location
  224/2, 598/4, // station 7 X, Y location
  288/2, 598/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    HS + 128, 507,   // station 1 X, Y location
//    VS + 160, 450,   // station 2 X, Y location
//    VS + 224, 413,   // station 3 X, Y location
//    VS + 288, 450,   // station 4 X, Y location
//    HS + 320, 507,   // station 5 X, Y location
//    VS + 160, 598,   // station 6 X, Y location
//    VS + 224, 598,   // station 7 X, Y location
//    VS + 288, 598    // station 8 X, Y location
};

// beta 19 is identical to alpha 9, except for ship starting position
const unsigned char beta_19[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0xe3,         // VS VS VS HS   HS HS VS VS
   64/2, 146/4, // station 1 X, Y location
  352/2, 256/4, // station 2 X, Y location
  292/2, 512/4, // station 3 X, Y location
  226/2, 562/4, // station 4 X, Y location
  164/2, 608/4, // station 5 X, Y location
  224/2, 768/4, // station 6 X, Y location
  416/2, 819/4, // station 7 X, Y location
   96/2, 920/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    VS + 64, 146,   // station 1 X, Y location
//    VS + 352, 256,   // station 2 X, Y location
//    HS + 292, 512,   // station 3 X, Y location
//    HS + 226, 562,   // station 4 X, Y location
//    HS + 164, 608,   // station 5 X, Y location
//    VS + 224, 768,   // station 6 X, Y location
//    VS + 416, 819,   // station 7 X, Y location
//    VS + 96, 920    // station 8 X, Y location
};

// beta 22 is identical to alpha 16, except for ship starting position
const unsigned char beta_22[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0x6c,         // HS VS VS HS   VS VS HS HS
  228/2, 224/4, // station 1 X, Y location
  100/2, 292/4, // station 2 X, Y location
   32/2, 455/4, // station 3 X, Y location
   64/2, 642/4, // station 4 X, Y location
  228/2, 769/4, // station 5 X, Y location
  352/2, 698/4, // station 6 X, Y location
  416/2, 512/4, // station 7 X, Y location
  384/2, 351/4  // station 8 X, Y location
  
//    253, 934,   // ship starting X, Y location
//    8,          // station count
//    HS + 228, 224,   // station 1 X, Y location
//    HS + 100, 292,   // station 2 X, Y location
//    VS + 32, 455,   // station 3 X, Y location
//    VS + 64, 642,   // station 4 X, Y location
//    HS + 228, 769,   // station 5 X, Y location
//    VS + 352, 698,   // station 6 X, Y location
//    VS + 416, 512,   // station 7 X, Y location
//    HS + 384, 351    // station 8 X, Y location
};

// 23 same as 17.  Starting with 23 they repeat in this order:
// beta_17,
// beta_18,
// beta_19,
// beta_14,
// alpha_17,
// beta_22

#ifdef COMPACT_LEVELS
const unsigned short int beta_levels[] =
{
  (unsigned short int) beta_1,     // 1
  (unsigned short int) beta_2,     // 2
  (unsigned short int) alpha_8,    // 3
  (unsigned short int) alpha_9,    // 4
  (unsigned short int) alpha_16,   // 5
  (unsigned short int) alpha_4,    // 6
  (unsigned short int) alpha_12,   // 7
  (unsigned short int) alpha_11,   // 8
  (unsigned short int) beta_9,     // 9
  (unsigned short int) beta_10,    // 10
  (unsigned short int) beta_11,    // 11
  (unsigned short int) alpha_8,    // 12
  (unsigned short int) alpha_9,    // 13
  (unsigned short int) beta_14,    // 14
  (unsigned short int) alpha_17,   // 15
  (unsigned short int) alpha_16,   // 16
  (unsigned short int) beta_17,    // 17 23 29
  (unsigned short int) beta_18,    // 18 24 ...
  (unsigned short int) beta_19,    // 19 25
  (unsigned short int) beta_14,    // 20 26
  (unsigned short int) alpha_17,   // 21 27
  (unsigned short int) beta_22     // 22 28
};

#else 

const unsigned char * const beta_levels[] =
{
    beta_1,     // 1
    beta_2,     // 2
    alpha_8,    // 3
    alpha_9,    // 4
    alpha_16,   // 5
    alpha_4,    // 6
    alpha_12,   // 7
    alpha_11,   // 8
    beta_9,     // 9
    beta_10,    // 10
    beta_11,    // 11
    alpha_8,    // 12
    alpha_9,    // 13
    beta_14,    // 14
    alpha_17,   // 15
    alpha_16,   // 16
    beta_17,    // 17 23 29
    beta_18,    // 18 24 ...
    beta_19,    // 19 25
    beta_14,    // 20 26
    alpha_17,   // 21 27
    beta_22     // 22 28
        
};
#endif
